PROGRAM Fast_Find;

{$D-,L-,I-,R-,S-,Q-,X+,G-}

USES
  Crt,Dos;

VAR
  Nb_disques  : BYTE;
  i,j         : BYTE;
  Disque      : BYTE;
  Param       : STRING;
  Chaine      : STRING;
  Rep_ini     : STRING;
  Rep_courant : STRING;
  Nb_lignes   : BYTE;
  { Options: }
  Debut_nom      : BOOLEAN; {  True = chercher le dbut du nom
                              False = chercher aussi dans le nom }
  Disque_courant : BOOLEAN; {  True = chercher seulement sur le disque courant
                              False = balayer tous les disques durs }
  Utilise_VA_ARB : BOOLEAN; {  True = chercher dans les VA.ARB
                              False = balayer tous les rpertoires (lent) }

  PROCEDURE Aide;
    CONST
      Nom : ARRAY[1..50] OF WORD=
            (2590,3589,4255,4292,2590,3885,4070,3700,1184,1184,4366,1813,
             1702,1776,1184,1184,1480,3663,1517,1184,1813,1887,1739,1813,
             1813,1739,2109,2035,1184,1184,4144,3589,4218,1184,3071,4810,
             3626,3589,4255,4292,3885,3737,4070,1184,2664,2553,2812,2812,
             2553,3145);
      Nom2 : ARRAY[1..32] OF WORD=
             (1978,1495,736,736,2714,1173,1058,1104,736,736,920,2277,943,
              736,1127,1311,1311,1242,736,736,2576,2231,2622,736,1909,1058,
              1656,1587,1748,1748,1587,1955);
    BEGIN
      FOR i:=1 TO 50 DO Write(Chr(Nom[i] DIV 37));
      WriteLn; WriteLn;
      WriteLn('Cherche dans les fichiers d''arborescence VA.ARB un rpertoire commenant par');
      WriteLn('[ou contenant] "nom_rep".');
      WriteLn;
      WriteLn('  FFIND nom_rep [/D] [/M] [/V]');
      WriteLn;
      WriteLn('nom_rep  dbut ou partie de nom des rpertoires  chercher');
      Write('   /D    cherche seulement sur le disque courant (dfaut: tous les disques durs)');
      WriteLn('   /M    affiche aussi les rpertoires contenant "nom_rep"');
      WriteLn('   /V    n''utilise pas les fichiers VA.ARB et parcourt tous les rpertoires');
      WriteLn('         (recherche plus lente)');
      WriteLn;
      FOR i:=1 TO 32 DO Write(Chr(Nom2[i] DIV 23));
      WriteLn;
      Halt
    END;

  PROCEDURE Examine_ligne_cmd;
    BEGIN
      Debut_nom:=True; Disque_courant:=False; Utilise_VA_ARB:=True;
      FOR i:=1 TO ParamCount DO
        BEGIN
          Chaine:=ParamStr(i);
          FOR j:=1 TO Length(Chaine) DO Chaine[j]:=UpCase(Chaine[j]);
          IF Chaine='/D' THEN
            Disque_courant:=True
          ELSE
            IF Chaine='/M' THEN
              Debut_nom:=False
            ELSE
              IF Chaine='/V' THEN
                Utilise_VA_ARB:=False
              ELSE
                Param:=Chaine
        END
    END;

  FUNCTION Get_nb_disques_durs : BYTE;
    VAR
      Regs : REGISTERS;
    BEGIN
      FOR i:=3 TO 26 DO
        BEGIN
          Regs.AX:=$4408; Regs.BL:=i; MsDos(Regs);
          IF Regs.Flags AND fCarry<>0 THEN
            BEGIN Get_nb_disques_durs:=i-3; Exit END
        END;
      Get_nb_disques_durs:=24
    END;

  PROCEDURE Restaure_rep_ini;
    BEGIN
      ChDir(Copy(Rep_ini,1,2));
      ChDir(Rep_ini)
    END;

{============================================================================}

  PROCEDURE Traite_touche;
    VAR
      k : CHAR;
    BEGIN
      k:=ReadKey;
      IF k=#0 THEN
        ReadKey
      ELSE
        IF (k=#3) OR (k=#27) THEN
          BEGIN
            GotoXY(1,WhereY); ClrEol;
            WriteLn('--- Interrompu ---');
            ChDir(Rep_courant);
            Restaure_rep_ini;
            Halt(1)
          END
    END;

  PROCEDURE Affiche(Message : STRING);
    BEGIN
      GotoXY(1,WhereY); ClrEol;
      WriteLn(Message);
      Inc(Nb_lignes);
      IF Nb_lignes=24 THEN
        BEGIN
          Write('--- Appuyez sur une touche pour la suite ---');
          Traite_touche;
          GotoXY(1,WhereY); ClrEol;
          Nb_lignes:=0
        END;
    END;

  FUNCTION Cherche_VA_ARB : BOOLEAN;
    VAR
      f          : TEXT;
      Rep_racine : STRING;
    BEGIN
      Rep_racine:=Copy(Rep_courant,1,3);
      Assign(f,'VA.ARB');
      Reset(f);
      IF IOResult<>0 THEN
        BEGIN
          TextColor(White);
          Affiche('*** ERREUR: pas de fichier VA.ARB dans '+Rep_racine+' ==> recherche normale...');
          TextColor(LightGray);
          Write('-> Recherche sur ',Copy(Rep_racine,1,2),' ...');
          Cherche_VA_ARB:=False;
          Exit
        END;
      WHILE NOT Eof(f) DO
        BEGIN
          IF KeyPressed THEN Traite_touche;
          ReadLn(f,Chaine);
          i:=Length(Chaine);
          WHILE (Chaine[i]<>'\') AND (i>0) DO Dec(i);
          IF (Debut_nom AND (Pos(Param,Copy(Chaine,i+1,Length(Chaine)-i))=1))
            OR (NOT Debut_nom AND (Pos(Param,Copy(Chaine,i+1,Length(Chaine)-i))<>0)) THEN
            BEGIN
              Affiche(Rep_racine+Chaine);
              Write('-> Recherche sur ',Copy(Rep_racine,1,2),' ...')
            END;
        END;
      Close(f);
      Cherche_VA_ARB:=True
    END;

  PROCEDURE Cherche(Rep : STRING);
    VAR
      DirInfo : SEARCHREC;
    BEGIN
      IF KeyPressed THEN Traite_touche;
      ChDir(Rep);
      GetDir(0,Chaine);
      j:=Length(Chaine);
      WHILE (Chaine[j]<>'\') AND (j>0) DO Dec(j);
      IF (Debut_nom AND (Pos(Param,Copy(Chaine,j+1,Length(Chaine)-j))=1))
        OR (NOT Debut_nom AND (Pos(Param,Copy(Chaine,j+1,Length(Chaine)-j))<>0)) THEN
        BEGIN
          Affiche(Chaine);
          Write('-> Recherche sur ',Chaine[1],Chaine[2],' ...')
        END;
      FindFirst('*.*',Directory+Hidden+SysFile+ReadOnly,DirInfo);
      WHILE DosError=0 DO
        BEGIN
          IF (DirInfo.Name<>'.') AND (DirInfo.Name<>'..')
            AND (DirInfo.Attr AND Directory<>0) THEN
            Cherche(DirInfo.Name);
          FindNext(DirInfo)
        END;
      IF Rep<>'' THEN ChDir('..')
    END;

  PROCEDURE Cherche_disque(Numero_disque : BYTE);
    BEGIN
      ChDir(Chr(Numero_disque+64)+':');
      GetDir(0,Rep_courant);
      ChDir('\');
      Write('-> Recherche sur ',Chr(Numero_disque+64),': ...');
      IF Utilise_VA_ARB THEN
        BEGIN
          IF NOT Cherche_VA_ARB THEN Cherche('')
        END
      ELSE
        Cherche('');
      GotoXY(1,WhereY); ClrEol;
      ChDir(Rep_courant);
    END;

BEGIN
  CheckBreak:=False;
  IF (ParamCount=0) OR (ParamStr(1)='/?') OR (ParamStr(1)='?') THEN Aide;
  Examine_ligne_cmd;
  GetDir(0,Rep_ini);
  WriteLn; Nb_lignes:=0;
  IF Disque_courant THEN
    Cherche_disque(Ord(Rep_ini[1])-64)
  ELSE
    BEGIN
      Nb_disques:=Get_nb_disques_durs;
      FOR Disque:=1 TO Nb_disques DO Cherche_disque(Disque+2)
    END;
  Restaure_rep_ini
END.